package com.gct.system.controller;

import com.gct.common.security.core.CheckTokenCaching;
import com.gct.common.security.core.JwtAuthenticatioToken;
import com.gct.common.security.util.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;


/**
 * <p>
 *  获取feign前端控制器
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-19
 */
@RestController
public class SysFeignController {

    @Autowired
    private CheckTokenCaching checkTokenCaching;
    @Autowired
    private AuthenticationManager authenticationManager;

    @GetMapping("/token")
    public String getFeignToken(HttpServletRequest request){
        JwtAuthenticatioToken token = SecurityUtils.login(request, "feign", "feign", authenticationManager,checkTokenCaching);
        return token.getToken();
    }
}

