package com.gct.system.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 *  菜单对象
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="SysMenu对象", description="菜单对象")
public class SysMenu implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "ID",type = IdType.ASSIGN_UUID)
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "资源名称")
    private String menuName;

    @ApiModelProperty(value = "菜单描述")
    private String menuDescription;

    @ApiModelProperty(value = "图标代码")
    private String icon;

    @ApiModelProperty(value = "路由地址")
    private String url;

    @ApiModelProperty(value = "类型 0：菜单 1：按钮")
    private Integer menuType;

    @ApiModelProperty(value = "显示状态 0：隐藏 1：显示")
    private Integer menuStatus;

    @ApiModelProperty(value = "排序序号")
    private Integer sort;

    @ApiModelProperty(value = "授权，多个用，隔开")
    private String perms;

    @ApiModelProperty(value = "创建人username")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "更新人username")
    @TableField(fill = FieldFill.UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.UPDATE)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "备用字段A")
    private String spareA;

    @ApiModelProperty(value = "备用字段B")
    private String spareB;

    @ApiModelProperty(value = "备用字段C")
    private String spareC;

    @ApiModelProperty(value = "备用字段D")
    private String spareD;

    @ApiModelProperty(value = "备用字段E")
    private String spareE;

    @ApiModelProperty(value = "上级ID")
    private String parentId;

    @ApiModelProperty(value = "层级")
    private Integer level;

    @ApiModelProperty(value = "排序用到字段")
    private String orderField;

    @ApiModelProperty(value = "子部门")
    @TableField(exist = false) //非数据库映射字段
    private List<SysMenu> children;


}
