package com.gct.system.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gct.system.entity.SysMenu;
import com.gct.system.entity.SysOrgRole;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
@Mapper
public interface SysMenuMapper extends BaseMapper<SysMenu> {


    List<SysMenu> findByUserName(@Param("username") String username);


    Integer getMaxSort();

    @Select("select *from sys_menu where \"id\" in( select menu_id from sys_role_menu where role_id=( select role_id from sys_user where username=#{?1})) and \"level\"<=#{?2} ORDER BY sort asc")
    List<SysMenu> finByUserName(@Param("?1") String username,@Param("?2") int level);

    @Select("select *from sys_menu where \"id\" in( select menu_id from sys_role_menu where role_id=#{?1}) and \"level\"<=#{?2} ORDER BY sort asc\n")
    List<SysMenu> findByRoleID(@Param("?1") String role_id,@Param("?2") int level);

    @Select("select * from sys_menu where \"level\"<=#{?1}")
    List<SysMenu> findAllByLevelLimit(@Param("?1") int maxLevel);

}
