package com.gct.system.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gct.system.entity.SysRole;
import org.apache.ibatis.annotations.*;
import org.springframework.security.core.parameters.P;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
@Mapper
public interface SysRoleMapper extends BaseMapper<SysRole> {

    @Delete("delete from sys_role_menu where role_id=#{?1}")
    int delRoleMenuRelationByRoleID(@Param("?1") String role);

    int delRoleMenuRelationByRoleIDBatch(@Param("roles") List<String> roles);

    @Select("select * from sys_role_menu where role_id=#{?1}")
    List<Map<String,Object>> selectRoleMenuRelationByRoleID(@Param("?1") String role);

    @Insert("insert into sys_role_menu(role_id,menu_id) values(#{?1},#{?2})")
    int insertRoleMenuRelation(@Param("?1") String role_id,@Param("?2") String menu_id);

    int insertRoleMenuRelationBatch(@Param("role") String role, @Param("data") List<String> data);
}
