package com.gct.system.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.entity.PageRequest;
import com.gct.common.core.result.Result;
import com.gct.system.entity.SysDept;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
public interface SysDeptService extends IService<SysDept> {

    /**
     * 添加部门
     * @param sysDept
     * @return
     */
    Result addDept(SysDept sysDept);

    /**
     * 修改部门
     * @param sysDept
     * @return
     */
    Result modifyDept(SysDept sysDept);

    /**
     * 分页查询部门信息
     * @param pageRequest
     * @return
     */
    Result findListByPages(PageRequest pageRequest);

    /**
     * 树形结构查询
     * @return
     */
    Result findTree();

    /**
     * 通过id查询该部门下的所有子部门id 列表
     * @param id
     * @return
     */
    List<String> findAllIdById(String id);

    /**
     * 所有部门列表
     * @return
     */
    Result findList();
}
