package com.gct.system.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.system.entity.SysMenu;
import com.gct.common.core.result.Result;
import com.gct.system.entity.SysOrgRole;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
public interface SysMenuService extends IService<SysMenu> {

    /**
     * 创建菜单
     * @param sysMenu
     * @return
     */
    Result createMenu(SysMenu sysMenu);

    /**
     * 更新菜单
     * @param sysMenu
     * @return
     */
    Result updateMenu(SysMenu sysMenu);

    /**
     * 获取菜单 通过用户名
     * @param username
     * @return
     */
    List<SysMenu> findByUser(String username);

    /**
     *
     * @return
     */
    Result findTree();

    List<SysMenu> findTree(int maxLevel);
    /**
     *
     * @return
     */
    Result findList();



    List<SysMenu> selectMenuListByUserName(String username, int maxLevel);

    List<SysMenu> selectMenuListByRoleID(String role, int maxLevel);


    List<SysMenu> selectMenuTreeByUserName(String username, int maxLevel);

    List<SysMenu> selectMenuTreeByRoleID(String role, int maxLevel);

    List<SysOrgRole> selectMenuTreeByOrgRoleID(String role, int maxLevel);
}
