package com.gct.system.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.system.entity.SysDept;
import com.gct.system.entity.SysRole;
import com.gct.common.core.result.Result;
import com.gct.common.core.entity.PageRequest;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-23
 */
public interface SysRoleService extends IService<SysRole> {

    /**
     * 添加角色
     * @param sysRole
     * @return
     */
    Result addRole(SysRole sysRole);

    boolean delRoleByIDs(List<String> ids);

    boolean delRoleMenuRelationByRoleID(String role);

    /**
     * 修改角色
     * @param sysRole
     * @return
     */
    Result modifyRole(SysRole sysRole);

    /**
     * 分页查询角色
     * @param pageNum
     * @param pageSize
     * @param deptId
     * @param roleName
     * @return
     */
    Result findRoleByPages(Integer pageNum, Integer pageSize, String deptId, String roleName);


    Result findList();

    boolean deleteRoleMenuRelationByRoleID(List<String> roles);
}
