package com.gct.system.service;

import com.gct.system.entity.SysUser;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.result.Result;
import com.gct.common.core.entity.PageRequest;

import java.util.Set;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author NewMeanning
 * @since 2020-12-19
 */
public interface SysUserService extends IService<SysUser> {

    /**
     * 新建用户
     * @param sysUser
     * @return
     */
    Result createUser(SysUser sysUser);

    /**
     * 修改用户
     * @param sysUser
     * @return
     */
    Result updateUser(SysUser sysUser);

    /**
     * 分页查询列表
     * @param pageRequest
     * @return
     */
    Result finUserListByPagesPlus(PageRequest pageRequest);

    /**
     * 根据用户名获取用户
     * @param username
     * @return
     */
    SysUser findUserByName(String username);

    /**
     * 分页查询用户列表
     * @param pageNum
     * @param pageSize
     * @param deptId
     * @param roleId
     * @param nickName
     * @return
     */
    Result findUserListByPages(Integer pageNum, Integer pageSize, String deptId, String roleId, String nickName);

    /**
     * 根据用户名获取权限
     * @param username
     * @return
     */
    Set<String> findPermissions(String username);
}
