package com.gct.system.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.system.entity.SysOrgRole;
import com.gct.system.entity.SysUser;
import com.gct.system.mapper.SysOrgRoleMapper;
import com.gct.system.service.SysOrgRoleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.system.service.SysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xsr
 * @since 2021-08-06
 */
@Service
public class SysOrgRoleServiceImpl extends ServiceImpl<SysOrgRoleMapper, SysOrgRole> implements SysOrgRoleService {

    @Autowired
    SysUserService sysUserService;

    @Override
    public String getOrgByRoleName(String username) {
        SysUser user = sysUserService.getOne(new QueryWrapper<SysUser>().eq("username", username));
        if (user == null)return null;
        SysOrgRole orgRole = baseMapper.selectOne(new QueryWrapper<SysOrgRole>().eq("role_id", user.getRoleId()));
        return orgRole.getOrgId();
    }
}
